<?php
/**
 * SOBI2 SEF extension for Joomla!
 *
 * @copyright   2009 JoomAce LLC
 * @license	    GNU General Public License
 * www.joomace.net
 * @package     sh404SEF
 */
 
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

	// ------------------  standard plugin initialize function - don't change ---------------------------
	global $sh_LANG, $shRebuildNonSef;
	$sefConfig = & shRouter::shGetConfig(); 
	$shLangName = '';
	$shLangIso = '';
	$title = array();
	$shItemidString = '';
	$dosef = shInitializePlugin($lang, $shLangName, $shLangIso, $option);
	if ($dosef == false) return;
	// ------------------  standard plugin initialize function - don't change ---------------------------

	// ------------------  load language file - adjust as needed ----------------------------------------
	$shLangIso = shLoadPluginLanguage( 'com_sobi2', $shLangIso, '_SH404SEF_SOBI2_HOME');
	// ------------------  load language file - adjust as needed ----------------------------------------

	if (!function_exists('getSobi2CatTitle')) {
		function getSobi2CatTitle($id, $option, $shLangName) {
			$sefConfig = & shRouter::shGetConfig();
			$categories = array();
			
			if(empty($sefConfig->SOBI2_Categories))
				$id = 0;
			while ($id > 1) {
				$database =& JFactory::getDBO();
				$database->setQuery('SELECT c.catid, c.name, p.parentid' . ' FROM #__sobi2_categories AS c' . ' LEFT JOIN #__sobi2_cats_relations AS p ON p.catid = c.catid' . ' WHERE c.catid = '.$id);
				if (!shTranslateUrl($option, $shLangName))  
					$rows = $database->loadRow(false);
				else 
					$rows = $database->loadRow(); 
				
				$name = ($sefConfig->SOBI2_CategoryId ? $id.$sefConfig->replacement : '').$rows[1];
				array_unshift($categories, $name);
				$id = $rows[2];
				if($sefConfig->SOBI2_Categories == '1')
					break;
			}
			return $categories;
		}
	}
	
	if (!function_exists('getSobi2ItemCatId')) {
		function getSobi2ItemCatId($id, $option, $shLangName) {
			$sefConfig = & shRouter::shGetConfig();
			
			$database =& JFactory::getDBO();
			$database->setQuery('SELECT catid FROM #__sobi2_cat_items_relations WHERE itemid = '.$id);
			if (!shTranslateUrl($option, $shLangName))  
				$rows = $database->loadRow(false);
			else 
				$rows = $database->loadRow();
				
			$name = $rows[0];
			return $name;
		}
	}

	if (!function_exists('getSobi2ItemTitle')) {
		function getSobi2ItemTitle($id, $option, $shLangName) {
			$sefConfig = & shRouter::shGetConfig();
			
			$database =& JFactory::getDBO();
			$database->setQuery('SELECT itemid, title FROM #__sobi2_item WHERE itemid = '.$id);
			if (!shTranslateUrl($option, $shLangName))  
				$rows = $database->loadRow(false);
			else 
				$rows = $database->loadRow(); 
				
			$name = ($sefConfig->SOBI2_ListingId ? $id.$sefConfig->replacement : '').$rows[1];
			return $name;
		}
	}
	
	if (empty($Itemid) && $sefConfig->shInsertGlobalItemidIfNone && !empty($shCurrentItemid)) {
		$string .= '&Itemid='.$shCurrentItemid;
		$Itemid = $shCurrentItemid; 
		shAddToGETVarsList('Itemid', $Itemid);
	}
	
	$Itemid = isset($Itemid) ? $Itemid : null;
	$limit = isset($limit) ? $limit : null;
	$limitstart = isset($limitstart) ? $limitstart : null;

	// insert component name from menu
	$shSobi2Name = shGetComponentPrefix($option);
	$shSobi2Name = empty($shSobi2Name) ?  getMenuTitle($option, null, $Itemid, null, $shLangName ) : $shSobi2Name;
	$shSobi2Name = (empty($shSobi2Name) || $shSobi2Name == '/') ? 'Listings':$shSobi2Name;
	if ($sefConfig->SOBI2_MenuTitle && !empty($shSobi2Name)) $title[] = $shSobi2Name;
	
	if (isset($tag)) {
		$title[] = 'tags';
		$title[] = $tag;
	}
	
	if(isset($catid)){
		if($catid == 0){
			$ItemCatId = getSobi2ItemCatId($sobi2Id, $option, $shLangName);
			//shSetURLVar($URI->path, 'catid', $ItemCatId); //$queryString
			$shRebuildNonSef[] = '&catid='.$ItemCatId;
			$title = array_merge($title, getSobi2CatTitle($ItemCatId, $option, $shLangName));
		} else
			$title = array_merge($title, getSobi2CatTitle($catid, $option, $shLangName));
	} elseif(isset($sobi2Id)) {
		$ItemCatId = getSobi2ItemCatId($sobi2Id, $option, $shLangName);
		$shRebuildNonSef[] = '&catid='.$ItemCatId;
		$title = array_merge($title, getSobi2CatTitle($ItemCatId, $option, $shLangName));
	}
	
	if(isset($sobi2Task)){
		switch($sobi2Task){
			case 'sobi2Details':
				if(isset($sobi2Id))
					$title[] = getSobi2ItemTitle($sobi2Id, $option, $shLangName);
				break;
			case 'editSobi':
				if(isset($sobi2Id))
					$title[] = getSobi2ItemTitle($sobi2Id, $option, $shLangName);
				$title[] = _SOBI2_LISTING_EDIT_ENTRY_BT;
				break;
			case 'rss':
			case 'search':
			case 'addNew':
				$tasks = array( 'rss' => 'RSS',
				'search' => _SOBI2_SEARCH_H,
				'addNew' => _SOBI2_ADD_NEW_ENTRY);
				$title[] = $tasks[$sobi2Task];
				break;
			default:
				$title[] = $sobi2Task;
		}
	} elseif(isset($letter)){
		$title[] = _SOBI2_ALPHA_HEADER;
		$title[] = $letter;
	}
	
	if (isset($format))
		$title[] = $format;
	
	shRemoveFromGETVarsList('sobi2Id');
	shRemoveFromGETVarsList('catid');
	shRemoveFromGETVarsList('sobi2Task');
	shRemoveFromGETVarsList('letter');
	shRemoveFromGETVarsList('format');
	shRemoveFromGETVarsList('no_html');
	shRemoveFromGETVarsList('tag');
	
	shRemoveFromGETVarsList('option');
	shRemoveFromGETVarsList('lang');
	if (!empty($Itemid)) 
	  shRemoveFromGETVarsList('Itemid');
	if (!empty($limit))
	  shRemoveFromGETVarsList('limit'); 
	if (isset($limitstart))
	  shRemoveFromGETVarsList('limitstart');

	// ------------------  standard plugin finalize function - don't change ---------------------------  
	if ($dosef){
		$string = shFinalizePlugin( $string, $title, $shAppendString, $shItemidString, 
			(isset($limit) ? @$limit : null), (isset($limitstart) ? @$limitstart : null), 
			(isset($shLangName) ? @$shLangName : null));
	  }      
	// ------------------  standard plugin finalize function - don't change ---------------------------

?>
	