<?php
/**
 *    @version [ Nightly Build ]
 *    @package hwdVideoShare
 *    @copyright (C) 2007 - 2009 Highwood Design
 *    @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 ***
 *    This program is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

// get general configuration data
require_once(JPATH_SITE.'/administrator/components/com_hwdvideoshare/config.hwdvideoshare.php');
require_once(JPATH_SITE.'/components/com_hwdvideoshare/hwdvideoshare.class.php');
$c = hwd_vs_Config::get_instance();

if (eregi('Itemid=[0-9]+', $string) === false) {

	global $Itemid;
	$hwdvsItemid = hwd_vs_tools::generateValidItemid($Itemid);
	$Itemid = isset($Itemid) ? @$Itemid : $hwdvsItemid;

} else {

	$arr = parse_url($string);
	parse_str($arr["query"], $data);
	$Itemid = $data['Itemid'];

}

// ------------------  standard plugin initialize function - don't change ---------------------------
global $sh_LANG, $sefConfig;
$shLangName = '';
$shLangIso = '';
$title = array();
$shItemidString = '';
$dosef = shInitializePlugin( $lang, $shLangName, $shLangIso, $option);
if ($dosef == false) return;

// ------------------  standard plugin initialize function - don't change ---------------------------
// ------------------  load language file - adjust as needed ----------------------------------------
//$shLangIso = shLoadPluginLanguage( 'com_XXXXX', $shLangIso, '_SEF_SAMPLE_TEXT_STRING');
// ------------------  load language file - adjust as needed ----------------------------------------

// remove common URL from GET vars list, so that they don't show up as query string in the URL
shRemoveFromGETVarsList('option');
shRemoveFromGETVarsList('lang');
if (!empty($Itemid))
  shRemoveFromGETVarsList('Itemid');
if (!empty($limit))
  shRemoveFromGETVarsList('limit');
if (isset($limitstart))
  shRemoveFromGETVarsList('limitstart'); // limitstart can be zero

// start by inserting the menu element title (just an idea, this is not required at all)
$task = isset($task) ? @$task : null;
$shSampleName = shGetComponentPrefix($option);
$shSampleName = empty($shSampleName) ?

getMenuTitle($option, $task, $Itemid, null, $shLangName) : $shSampleName;
$shSampleName = (empty($shSampleName) || $shSampleName == '/') ? 'SampleCom':$shSampleName;

if (empty($limit)) {
  $limit = $c->vpp;
  shAddToGETVarsList('limit', $limit);
  shRemoveFromGETVarsList('limit');
}

switch ($task) {
	case 'ajax_rate':
	case 'ajax_addtofavourites':
	case 'ajax_removefromfavourites':
	case 'ajax_reportvideo':
	case 'ajax_addvideotogroup':
	case 'grabjomsocialplayer':
	case 'downloadfile':
	case 'deliverthumb':
	  $dosef = false;  // these tasks do not require SEF URL
	break;

	case 'upload':
    	$title[] = 'Upload-Video';
	    shRemoveFromGETVarsList('task');
	break;

	case 'upldconfirma3':
	case 'upldconfirma2':
	case 'upldconfirma1':
	case 'upldconfirmb0':
    	$title[] = 'Uploaded-Local';
	    shRemoveFromGETVarsList('task');
	break;

	case 'addconfirm':
    	$title[] = 'Uploaded';
	    shRemoveFromGETVarsList('task');
	break;

	/** group functions */
	case 'groups':
    	$title[] = 'Groups';
	    shRemoveFromGETVarsList('task');
	break;

	case 'creategroup':
    	$title[] = 'Create-Group';
	    shRemoveFromGETVarsList('task');
	break;

	case 'savegroup':
    	$title[] = 'Save-Groups';
	    shRemoveFromGETVarsList('task');
	break;

	case 'deletegroup':
    	$title[] = 'Delete-Groups';
	    shRemoveFromGETVarsList('task');
	break;

	case 'viewgroup':
    	$title[] = 'View-Group';
	    shRemoveFromGETVarsList('task');
	break;

	case 'joingroup':
    	$title[] = 'Join-Group';
	    shRemoveFromGETVarsList('task');
	break;

	case 'leavegroup':
    	$title[] = 'Leave-Group';
	    shRemoveFromGETVarsList('task');
	break;

	/** user functions */
	case 'yourvids':
    	$title[] = 'Your-Uploaded-Videos';
	    shRemoveFromGETVarsList('task');
	break;

	case 'yourfavs':
    	$title[] = 'Your-Favourite-Videos';
	    shRemoveFromGETVarsList('task');
	break;

	case 'yourgroups':
    	$title[] = 'Your-Groups';
	    shRemoveFromGETVarsList('task');
	break;

	case 'yourmemberships':
    	$title[] = 'Your-Group-Memberships';
	    shRemoveFromGETVarsList('task');
	break;

	case "editvideo":
    	$title[] = 'Edit-Your-Video';
	    shRemoveFromGETVarsList('task');
	break;

	case "savevideo":
    	$title[] = 'Save-Video';
	    shRemoveFromGETVarsList('task');
	break;

	case "deletevideo":
    	$title[] = 'Delete-Video';
	    shRemoveFromGETVarsList('task');
	break;

	case "featuredvids":
    	$title[] = 'Featured-Videos';
	    shRemoveFromGETVarsList('task');
	break;

	case "featuredgroups":
    	$title[] = 'Featured-Groups';
	    shRemoveFromGETVarsList('task');
	break;

	/** standard interaction functions */
	case 'rate':
    	$title[] = 'Rate-Video';
	    shRemoveFromGETVarsList('task');
	break;

	case 'favourite':
    	$title[] = 'Add-to-Favourites';
	    shRemoveFromGETVarsList('task');
	break;

	case 'removefavourite':
    	$title[] = 'Remove-from-Favourites';
	    shRemoveFromGETVarsList('task');
	break;

	case 'addv2g':
    	$title[] = 'Add-video-to-Group';
	    shRemoveFromGETVarsList('task');
	break;

	case 'flagvideo':
    	$title[] = 'Report-Video';
	    shRemoveFromGETVarsList('task');
	break;

	case 'flaggroup':
    	$title[] = 'Report-Group';
	    shRemoveFromGETVarsList('task');
	break;

	case 'nextvideo':
    	$title[] = 'Next-Video';
	    shRemoveFromGETVarsList('task');
	    shRemoveFromGETVarsList('category_id');
	    shRemoveFromGETVarsList('video_id');
	break;

	case 'previousvideo':
    	$title[] = 'Previous-Video';
	    shRemoveFromGETVarsList('task');
	    shRemoveFromGETVarsList('category_id');
	    shRemoveFromGETVarsList('video_id');
	break;

	/** user functions */
	case 'search':
    	$title[] = 'Search-Videos';
    	if (isset($category_id)) {
    		$title[] = $category_id;
    		shRemoveFromGETVarsList('category_id');
    	}
    	if (isset($category_id)) {
    		$title[] = $pattern;
    		shRemoveFromGETVarsList('pattern');
    	}
	    shRemoveFromGETVarsList('task');
	break;

	case 'displayresults':
    	$title[] = 'Search-Video-Results';
    	if (isset($category_id)) {
    		$title[] = $category_id;
    		shRemoveFromGETVarsList('category_id');
    	}
    	if (isset($category_id)) {
    		$title[] = $pattern;
    		shRemoveFromGETVarsList('pattern');
    	}
	    shRemoveFromGETVarsList('task');
	break;

	/** view function */
	case 'viewvideo' :
    	$title[] = 'View-Video';
	    shRemoveFromGETVarsList('task');
	break;

	/** category functions */
	case 'categories':
    	$title[] = 'Categories';
	    shRemoveFromGETVarsList('task');
	break;

	case 'viewcategory':
    	$title[] = 'View-Category';
	    shRemoveFromGETVarsList('task');
	break;

	case 'gotocategory':
		$menu = &JMenu::getInstance('site');
		$mparams = &$menu->getParams($Itemid);
		$hwdmcid = $mparams->get( 'hwdmcid', '');
    	$title[] = $hwdmcid;
    	$title[] = 'View-Single-Category';
	    shRemoveFromGETVarsList('task');

	break;

	/** rss functions */
	case 'rss' :
    	$title[] = 'RSS-Feeds';
	    shRemoveFromGETVarsList('task');
    	$title[] = $feed;
	    shRemoveFromGETVarsList('feed');
	break;

	default:
    $title[] = 'Videos';                                                     // insert a 'View sample' string,
                                                                             // according to language
                                                                             // only if you have defined the
	  if (!empty($sampleId)) {                                               // fetch some data about the content
      $q = 'SELECT id, title FROM #__samplenames WHERE id = '.$sampleId;     // select clause includes id, even if
      $database->setQuery($q);                                               // we don't need it, in order for Joomfish to
                                                                             // return a translated version

      if (shTranslateUrl($option, $shLangName)) // V 1.2.4.m                 // get it in the right language
        $database->loadObject( $sampleTitle);
      else $database->loadObject( $sampleTitle, false);                      // second param at false forces Joomfish to
                                                                             // return default language version instead of
                                                                             // current language

      if ($sampleTitle) {                                                    // if we found a title for this element
        $title[] = $sampleTitle->title;                                      // insert it in URL array
        shRemoveFromGETVarsList('sampleId');                                 // remove sampleId var from GET vars list
                                                                             // as we have found a text equivalent
      }
    }
	shRemoveFromGETVarsList('task');                                         // also remove task, as it is not needed
	                                                                         // because we can revert the SEF URL without
	                                                                         // it
}

if (isset($video_id)) {
  $query  = "SELECT title, category_id FROM #__hwdvidsvideos" ;
  $query .= "\n WHERE id= ".$video_id;
  $database->setQuery( $query );
  $sh404 = $database->loadObject();

  $query  = "SELECT category_name FROM #__hwdvidscategories" ;
  $query .= "\n WHERE id= ".$sh404->category_id;
  $database->setQuery( $query );
  $sh404_cat = $database->loadResult();
  $title[] = html_entity_decode($sh404_cat);
  $title[] = $video_id;
  $title[] = $sh404->title;
  shRemoveFromGETVarsList('video_id');
}
if (isset($cat_id)) {
  $query  = "SELECT category_name FROM #__hwdvidscategories" ;
  $query .= "\n WHERE id= ".$cat_id;
  $database->setQuery( $query );
  $sh404_title = $database->loadResult();
  $sh404_title = hwdEncoding::charset_encode_utf_8($sh404_title);
  $title[] = $cat_id;
  $title[] = $sh404_title;
  shRemoveFromGETVarsList('cat_id');
}
if (isset($group_id)) {
  $query  = "SELECT group_name FROM #__hwdvidsgroups" ;
  $query .= "\n WHERE id= ".$group_id;
  $database->setQuery( $query );
  $sh404_title = $database->loadResult();
  $sh404_title = hwdEncoding::charset_encode_utf_8($sh404_title);
  $title[] = $group_id;
  $title[] = $sh404_title;
  shRemoveFromGETVarsList('group_id');
}

// ------------------  standard plugin finalize function - don't change ---------------------------
if ($dosef){
   $string = shFinalizePlugin( $string, $title, $shAppendString, $shItemidString,
      (isset($limit) ? @$limit : null), (isset($limitstart) ? @$limitstart : null),
      (isset($shLangName) ? @$shLangName : null));
}
// ------------------  standard plugin finalize function - don't change ---------------------------

?>
