<?php
/*
* zOOm Media Gallery extension for sh404sef Component
* 2008-07-10 Guillermo Vargas <guille@vargas.co.cr>
* http://joomla.vargas.co.cr
*
*/

// Security check to ensure this file is being included by a parent file.
if (!defined('_JEXEC') && !defined('_VALID_MOS')) die('Direct Access to this location is not allowed.');

if (!defined('_SEF_ZMG_FUNC')) {
    define ('_SEF_ZMG_FUNC',1);

    /**
     * Helper function to get parent and sub category tree array for building URL
     */
    function ZMGSEF_GetCategoryArray($catid)
    {
	if (defined('JPATH_SITE')) {
        	$database = &JFactory::getDBO();
	} else {
		global $database;
	}
		
        static $tree = false;
        if (!$tree){
            $database->setQuery("SELECT `catname`, `catid`, `subcat_id` FROM `#__zoom`");
            $tree = $database->loadObjectList('catid');
        }
        $title = array();
        while ($catid != 0) {
            $title[] = $tree[$catid]->catname;
            $title[] = '/';
            $catid = $tree[$catid]->subcat_id;
        }
	

        return array_reverse($title);
    }

    function ZMGSEF_GetCategoryName($catid)
    {
	if (defined('JPATH_SITE')) {
        	$database = &JFactory::getDBO();
	} else {
		global $database;
	}

        $cat = null;
        $database->setQuery("SELECT `catname`, `catid` FROM `#__zoom` WHERE `catid` = '$catid' LIMIT 1");
        $database->loadObject($cat);

        return (isset($cat->catname) ? $cat->catname : '');
    }


    function ZMGSEF_GetOrderMethod() {
	static $zoomConfig;
	if (!$zoomConfig) {
		if (defined('JPATH_SITE')) {
			include(JPATH_SITE.DS.'components'.DS.'com_zoom'.DS.'etc'.DS.'zoom_config.php');
		} else {
			global $mosConfig_absolute_path;
			include($mosConfig_absolute_path. '/components/com_zoom/etc/zoom_config.php');
		}
	}
	# var_dump($zoomConfig);
	switch ($zoomConfig['orderMethod']) {
		case 1:
			return "imgdate ASC";
			break;
		case 2:
			return "imgdate DESC";
			break;
		case 3:
			return "imgfilename ASC";
			break;
		case 4:
			return "imgfilename DESC";
			break;
		case 5:
			return "imgname ASC";
			break;
		case 6:
			return "imgname DESC";
			break;
	}
    }

    function ZMGSEF_GetMediaName($catid,$key)
    {
        global $zoom;
	if (defined('JPATH_SITE')) {
        	$database = &JFactory::getDBO();
	} else {
		global $database;
	}

	$orderMethod = ZMGSEF_GetOrderMethod();
        $media = null;
	if ( $zoom->_isAdmin ) {
        	$database->setQuery("SELECT `imgname`, `imgid` FROM `#__zoomfiles` WHERE `catid` = '$catid' ORDER BY $orderMethod");
	} else {
        	$database->setQuery("SELECT `imgname`, `imgid` FROM `#__zoomfiles` WHERE `catid` = '$catid' and published=1 ORDER BY $orderMethod");
	}
	# echo $database->getQuery();
	$rows = $database->loadObjectList();
	$media = $rows[$key];

        return (isset($media->imgname) ? $media->imgname : '');
    }

}


// Load the texts to use in URL
global $sh_LANG, $sefConfig;
$shLangName = '';
$shLangIso = '';
$title = array();
$shItemidString = '';
$dosef = shInitializePlugin( $lang, $shLangName, $shLangIso, $option);

$texts = &$sh_LANG[$shLangIso];

// Create an associative array for page => url_text conversion
$pages = array();
$pages['admin'] =       isset($texts['_SH404SEF_ZOOM_ADMIN']) ? $texts['_SH404SEF_ZOOM_ADMIN'] : 'Admin';
$pages['upload'] =      isset($texts['_SH404SEF_ZOOM_UPLOAD']) ? $texts['_SH404SEF_ZOOM_UPLOAD'] : 'Upload';
$pages['catsmgr'] =     isset($texts['_SH404SEF_ZOOM_CATSMGR']) ? $texts['_SH404SEF_ZOOM_CATSMGR'] : 'Gallery Manager';
$pages['mediamgr'] =    isset($texts['_SH404SEF_ZOOM_MEDIAMGR']) ? $texts['_SH404SEF_ZOOM_MEDIAMGR'] : 'Media Manager';
$pages['zoomthumb'] =   isset($texts['_SH404SEF_ZOOM_ZOOMTHUMB']) ? $texts['_SH404SEF_ZOOM_ZOOMTHUMB'] : 'Thumb Coder';
$pages['settings'] =    isset($texts['_SH404SEF_ZOOM_SETTINGS']) ? $texts['_SH404SEF_ZOOM_SETTINGS'] : 'Settings';
$pages['optimize'] =    isset($texts['_SH404SEF_ZOOM_OPTIMIZE']) ? $texts['_SH404SEF_ZOOM_OPTIMIZE'] : 'Optimize';
$pages['ecard'] =       isset($texts['_SH404SEF_ZOOM_ECARD']) ? $texts['_SH404SEF_ZOOM_ECARD'] : 'e-card';
$pages['lightbox'] =    isset($texts['_SH404SEF_ZOOM_LIGHTBOX']) ? $texts['_SH404SEF_ZOOM_LIGHTBOX'] : 'Lightbox';
$pages['quicksearch'] = isset($texts['_SH404SEF_ZOOM_QUICKSEARCH']) ? $texts['_SH404SEF_ZOOM_QUICKSEARCH'] : 'Quick Search';
$pages['search'] =      isset($texts['_SH404SEF_ZOOM_SEARCH']) ? $texts['_SH404SEF_ZOOM_SEARCH'] : 'Search';
$pages['credits'] =     isset($texts['_SH404SEF_ZOOM_CREDITS']) ? $texts['_SH404SEF_ZOOM_CREDITS'] : 'Credits';
$pages['view'] =        isset($texts['_SH404SEF_ZOOM_VIEW']) ? $texts['_SH404SEF_ZOOM_VIEW'] : 'View';
$pages['editimg'] =     isset($texts['_SH404SEF_ZOOM_EDITIMG']) ? $texts['_SH404SEF_ZOOM_EDITIMG'] : 'Edit Media';

$sortings = array();
$sortings[0] = isset($texts['_SH404SEF_ZOOM_TOPTEN']) ? $texts['_SH404SEF_ZOOM_TOPTEN'] : 'Top Ten';
$sortings[1] = isset($texts['_SH404SEF_ZOOM_LASTSUBMITTED']) ? $texts['_SH404SEF_ZOOM_LASTSUBMITTED'] : 'Last submitted';
$sortings[2] = isset($texts['_SH404SEF_ZOOM_LASTCOMMENTED']) ? $texts['_SH404SEF_ZOOM_LASTCOMMENTED'] : 'Last commented';
$sortings[4] = isset($texts['_SH404SEF_ZOOM_TOPRATED']) ? $texts['_SH404SEF_ZOOM_TOPRATED'] : 'Top Rated';

$tasks = array();
$tasks['edtimg']    = isset($texts['_SH404SEF_ZOOM_EDITIMG']) ? $texts['_SH404SEF_ZOOM_EDITIMG'] : 'Edit Media';
$tasks['step']      = isset($texts['_SH404SEF_ZOOM_STEP']) ? $texts['_SH404SEF_ZOOM_STEP'] : 'Step';
$tasks['step1']     = isset($texts['_SH404SEF_ZOOM_STEP1']) ? $texts['_SH404SEF_ZOOM_STEP1'] : 'Step1';
$tasks['step2']     = isset($texts['_SH404SEF_ZOOM_STEP2']) ? $texts['_SH404SEF_ZOOM_STEP2'] : 'Step2';
$tasks['step3']     = isset($texts['_SH404SEF_ZOOM_STEP3']) ? $texts['_SH404SEF_ZOOM_STEP3'] : 'Step3';
$tasks['step4']     = isset($texts['_SH404SEF_ZOOM_STEP4']) ? $texts['_SH404SEF_ZOOM_STEP4'] : 'Step4';

/**
 * Use this to get variables from the original Joomla! URL, such as $task, $page, $id, $catID, ...
 */
$title = array();

$title[] = getMenuTitle(@$option, @$task, @$Itemid);
$title[] = '/';
$ignoreSefVars = array();
	

/**
 * Get category tree (parent cat and sub cats).
 */
$categories = 2; /* 0: dont include, 1: just the parent gallery, 2: all subgalleries */

if (isset($catid) && ($catid != 0) && (@$page != 'zoomthumb') && (@$page != 'mediamgr') && (@$page != 'upload') && (@$task != 'edtimg') && (@$page != 'lightbox')  ) {
    if( $categories != '0' ) {
        if( $categories == '1' ) {
            $title[] = ZMGSEF_GetCategoryName($catid);
	    $title[] = '/';
        } else {
            $title = array_merge($title, ZMGSEF_GetCategoryArray($catid));
        }
    }
   shRemoveFromGETVarsList('catid');
}

if ( isset($key) && (@$page != 'mediamgr') && (@$task != 'editimg') && (@$page != 'lightbox') ) {
    $title[] = ZMGSEF_GetMediaName($catid,$key);
    shRemoveFromGETVarsList('key');
    shRemoveFromGETVarsList('catid');
}

if( isset($page) ) {
    switch($page) {
        case 'catsmgr':
        case 'upload':
        case 'mediamgr':
        case 'zoomthumb':
        case 'settings':
        case 'editimg':
            $title[] = $pages['admin'];
	    $title[] = '/';
            $title[] = $pages[$page];

            if( ($page == 'mediamgr') ) {
                if( @$task == 'edtimg' ) {
	    		$title[] = '/';
			$title[] = $tasks['edtimg'];
		}
                if( isset($catid) ) {
	    		$title[] = '/';
			$title[] = $catid;
		}
                if( isset($key) ) {
	    		$title[] = '/';
			$title[] = $key;
		}
            }

            if( ($page == 'zoomthumb') && isset($task) ) {
                if( in_array($task, array_keys($tasks)) ) {
                    $title[] = $tasks[$task];
                }
                if( isset($catid) ) {
			$title[] = $catid;
		}
                if( isset($imgid) ) {
			$title[] = $imgid;
		}
            }
            break;

        case 'admin':
            $title[] = $pages['admin'];
            if( isset($action) && ($action == 'optimize') ) {
                $title[] = $pages['optimize'];
            }
            break;

        case 'special':
            if( isset($sorting) && in_array($sorting, array_keys($sortings)) ) {
                $title[] = $sortings[$sorting];
            }
            break;

        case 'ecard':
        case 'lightbox':
        case 'view':
        case 'credits':
            if( in_array($page, array_keys($pages)) ) {
                $title[] = $pages[$page];
            }
            break;

        case 'search':
            if( isset($type) && ($type == 'quicksearch') ) {
                $title[] = $pages['quicksearch'];
            } else {
                $title[] = $pages['search'];
            }
	    $title[] = '/';
            break;
    }

}

# $nonSefVars = array();
# if( isset($sorting) )   $nonSefVars['sorting'] = $sorting;
# if( isset($sstring) )   $nonSefVars['sstring'] = $sstring;
# if( isset($PageNo) )    $nonSefVars['PageNo'] = $PageNo;
# if( isset($offset) )    $nonSefVars['offset'] = $offset;

// Only add these variables when their values aren't default
# if( isset($hit) && ($hit != 1) )        $nonSefVars['hit'] = $hit;

shRemoveFromGETVarsList('option');
shRemoveFromGETVarsList('lang');
if (!empty($Itemid))
  shRemoveFromGETVarsList('Itemid');
if (!empty($limit))
  shRemoveFromGETVarsList('limit');
if (isset($limitstart))
  shRemoveFromGETVarsList('limitstart');
if (isset($page))
  shRemoveFromGETVarsList('page');
if (isset($action))
  shRemoveFromGETVarsList('action');




// ------------------  standard plugin finalize function - don't change ---------------------------
if ($dosef){
  $string = shFinalizePlugin( $string, $title, $shAppendString, $shItemidString,
  (isset($limit) ? @$limit : null), (isset($limitstart) ? @$limitstart : null),
  (isset($shLangName) ? @$shLangName : null));
}
// ------------------  standard plugin finalize function - don't change ---------------------------

return $string;
?>
