<?php
/**
 * sh404SEF support for com_eventlist component.
 * @Author : Jorge Adrian Levano (jrgadrian)
 * @copyright: (C) 2008 - 2009 Adrian Levano
 * @contact : jrgadrian@gmail.com
 * 
 * {shSourceVersionTag: Version 1.0 - 2008-04-01}
 * 
 * This is a sh404SEF native plugin file
 *    
 */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

// ------------------  standard plugin initialize function - don't change ---------------------------
global $sh_LANG, $sefConfig;  
$shLangName = '';
$shLangIso = '';
$title = array();
$shItemidString = '';
$dosef = shInitializePlugin( $lang, $shLangName, $shLangIso, $option);
if ($dosef == false) return;
// ------------------  standard plugin initialize function - don't change ---------------------------

// ------------------  load language file - adjust as needed ----------------------------------------
$shLangIso = shLoadPluginLanguage( 'com_eventlist', $shLangIso, '_SH404SEF_ELIST_ALL_EVENTS');
// ------------------  load language file - adjust as needed ----------------------------------------

$view = isset($view) ? @$view : null;
$Itemid = isset($Itemid) ? @$Itemid : null;
$shEventsName = shGetComponentPrefix($option); 
$shEventsName = empty($shEventsName) ?  
		getMenuTitle($option, $view, $Itemid, null, $shLangName) : $shEventsName;
$shEventsName = (empty($shEventsName) || $shEventsName == '/') ? 'Events':$shEventsName;
if (!empty($shEventsName)) $title[] = $shEventsName;

switch ($view) {
  case 'details':                                
    if (!empty($id)) {
	    $query = ' SELECT e.id, e.title, e.catsid FROM #__eventlist_events AS e'
	    		.' WHERE e.id = "'.$id.'"';
	    $database->setQuery($query);
	    if (shTranslateURL($option, $shLangName))
	      $event = $database->loadObject( );
	    else  $event = $database->loadObject( false );
	    $query = 'SELECT id, catname FROM #__eventlist_categories WHERE id = "'.$event->catsid.'"';
	    $database->setQuery($query);
	    if (shTranslateURL($option, $shLangName))
	      $category = $database->loadObject( );
	    else  $category = $database->loadObject( false );
	    if( !empty( $category ) ){
			$title[] = $category->catname;
		}
	    if( !empty( $event ) ){
		    $title[] = $event->id.' '.$event->title;
	    }
	    shRemoveFromGETVarsList('id');
    }
    else $title[] = '/';
  break;
  case 'categoryevents':
  	if (!empty($id)) {
	    $query = 'SELECT id, catname FROM #__eventlist_categories WHERE id = "'.$id.'"';
	    $database->setQuery($query);
	    if (shTranslateURL($option, $shLangName))
	      $rows = $database->loadObjectList( );
	    else  $rows = $database->loadObjectList( null, false);
	    if ($database->getErrorNum()) {
		    die( $database->stderr());
	    }elseif( @count( $rows ) > 0 ){
		    if( !empty( $rows[0]->catname ) ){
			    $title[] = $rows[0]->catname;
		    }
	    }
	    shRemoveFromGETVarsList('id');
    }
  break;
  case 'venueevents':
  	if (!empty($id)) {
	    $query = 'SELECT venue, id FROM #__eventlist_venues WHERE id = "'.$id.'"';
	    $database->setQuery($query);
	    if (shTranslateURL($option, $shLangName))
	      $rows = $database->loadObjectList( );
	    else  $rows = $database->loadObjectList( null, false);
	    if ($database->getErrorNum()) {
		    die( $database->stderr());
	    }elseif( @count( $rows ) > 0 ){
		    if( !empty( $rows[0]->venue ) ){
			    $title[] = $rows[0]->venue;
		    }
	    }
	    shRemoveFromGETVarsList('id');
    }
  break;
  case 'categories':
	  $title[] = $sh_LANG[$shLangIso]['_SH404SEF_ELIST_CATEGORIES'] . $sefConfig->suffix;
  break;
  case 'categoriesdetailed':
	  $title[] = $sh_LANG[$shLangIso]['_SH404SEF_ELIST_DETAILED_CATEGORIES'] . $sefConfig->suffix;
  break;
  case 'categoryevents':
	  $title[] = $sh_LANG[$shLangIso]['_SH404SEF_ELIST_CATEGORY_EVENTS'] . $sefConfig->suffix;
  break;
  case 'day':
	  $title[] = $sh_LANG[$shLangIso]['_SH404SEF_ELIST_DAY_EVENTS'] . $sefConfig->suffix;
  break;
  case 'editevent':
	  $title[] = $sh_LANG[$shLangIso]['_SH404SEF_ELIST_EVENT_SUBMISSION'] . $sefConfig->suffix;
  break;
  case 'editvenue':
	  $title[] = $sh_LANG[$shLangIso]['_SH404SEF_ELIST_VENUE_SUBMISSION'] . $sefConfig->suffix;
  break;
  case 'eventlist':
	  $title[] = $sh_LANG[$shLangIso]['_SH404SEF_ELIST_ALL_EVENTS'] . $sefConfig->suffix;
  break;
  case 'venueevents':
	  $title[] = $sh_LANG[$shLangIso]['_SH404SEF_ELIST_VENUE_EVENTS'] . $sefConfig->suffix;
  break;
  case 'venues':
	  $title[] = $sh_LANG[$shLangIso]['_SH404SEF_ELIST_VENUES'] . $sefConfig->suffix;
  break;
  default:
  	  $title[] = $sh_LANG[$shLangIso]['_SH404SEF_ELIST_ALL_EVENTS'] . $sefConfig->suffix;
  break;
}

shRemoveFromGETVarsList('option');
shRemoveFromGETVarsList('lang');
if (!empty($Itemid))
  shRemoveFromGETVarsList('Itemid');
if (!empty($limit))  
shRemoveFromGETVarsList('limit');
if (isset($limitstart)) 
  shRemoveFromGETVarsList('limitstart'); // limitstart can be zero
if (!empty($view))
  shRemoveFromGETVarsList('view');
  
// ------------------  standard plugin finalize function - don't change ---------------------------  
if ($dosef){
   $string = shFinalizePlugin( $string, $title, $shAppendString, $shItemidString, 
      (isset($limit) ? @$limit : null), (isset($limitstart) ? @$limitstart : null), 
      (isset($shLangName) ? @$shLangName : null));
}      
// ------------------  standard plugin finalize function - don't change ---------------------------
  
?>
